module.exports = {
  roots: ["<rootDir>"],
  testEnvironment: "jsdom",
  moduleFileExtensions: ["ts", "tsx", "js", "json", "jsx"],
  testPathIgnorePatterns: ["<rootDir>[/\\\\](node_modules|.next)[/\\\\]"],
  transformIgnorePatterns: [
    "[/\\\\]node_modules[/\\\\].+\\.(ts|tsx)$",
    "^.+\\.module\\.(css|sass|scss)$",
  ],
  transform: {
    "^.+\\.(js|jsx|ts|tsx)$": ["babel-jest", { presets: ["next/babel"] }],
  },
  watchPlugins: ["jest-watch-typeahead/filename", "jest-watch-typeahead/testname"],
  setupFiles: ["fake-indexeddb/auto"],
  setupFilesAfterEnv: ["<rootDir>/jest.setup.js"],
  moduleNameMapper: {
    "\\.(css|less|sass|scss)$": "identity-obj-proxy",
    "\\.(jpg|jpeg|png|gif|eot|otf|webp|svg|ttf|woff|woff2|mp4|webm|wav|mp3|m4a|aac|oga)$":
      "<rootDir>/__mocks__/fileMock.js",
    "next/config": "<rootDir>/test/__mocks__/next/config.ts",
    "next-i18next": "<rootDir>/test/__mocks__/next-i18next.js",
    "react-i18next": "<rootDir>/test/__mocks__/next-i18next.js",
    "^@/store/index$": "<rootDir>/test/__mocks__/store.js",
    "^@/components/(.*)$": "<rootDir>/src/component/$1",
    "^@/enums/(.*)$": "<rootDir>/src/enums/index",
    "^@/hooks/(.*)$": "<rootDir>/src/hooks/$1",
    "^@/interfaces/(.*)$": "<rootDir>/src/interfaces/$1",
    "^@/pages/(.*)$": "<rootDir>/src/pages/$1",
    "^@/services/(.*)$": "<rootDir>/src/services/$1",
    "^@/store/(.*)$": "<rootDir>/src/store/$1",
    "^@/styles/(.*)$": "<rootDir>/src/styles/$1",
    "^@/types/(.*)$": "<rootDir>/src/types/index",
    "^@/utils/(.*)$": "<rootDir>/src/utils/$1",
    "^@/libs/(.*)$": "<rootDir>/src/libs/$1",
    "^@/constants/(.*)$": "<rootDir>/src/constants/$1",
    "^@/providers/(.*)$": "<rootDir>/src/providers/$1",
    "^@/tests/(.*)$": "<rootDir>/test/$1",
    "ˆ@/apollo/(.*)$": "<rootDir>/apollo/$1",
  },
  moduleDirectories: ["node_modules", "src", "utils", "apollo"],
};
